;******************************************************************************
; Free386 define
;******************************************************************************
;[TAB=8]
;
;==============================================================================
; Version setting
;==============================================================================
%define	VER_STRING	'Ver0.64 2021/01/01'
Major_ver	equ		00h
Minor_ver	equ		64h
F386_Date	equ		20210101h	;Develop date

;==============================================================================
; Operation setting
;==============================================================================
%ifndef AUTO_RELEASE
; Target Machine / If all of zero, for DOS general purpose binary.
TOWNS		equ	0	; for FM-TOWNS binary
PC_98		equ	0	; for PC-98x1 binary
PC_AT		equ	0	; for PC/AT binary

; for DEVELOP build
MEMORY_INFO	equ	0	; Internal 64KB memory information with -v opt.
INT_HOOK	equ	0	; interrupt hook and register dump
INT_HOOK_F386	equ	0	; (DANGER!) with F386 CS's INT
INT_REGDUMP	equ	0ffh	; interrupt for user program register dump
PRINT_TO_FILE	equ	0	; int 21/ah=09h, Force output to "dump.txt" file

%else

; for RELEASE
MEMORY_INFO	equ	0	; Internal 64KB memory information with -v opt.
INT_HOOK	equ	0	; interrupt hook and register dump
INT_HOOK_F386	equ	0	; (DANGER!) with F386 CS's INT
INT_REGDUMP	equ	0ffh	; interrupt for user program register dump
PRINT_TO_FILE	equ	0	; int 21/ah=09h, Force output to "dump.txt" file

%endif

;==============================================================================
; Settings
;==============================================================================
USE_MZ_EXP	equ	1	; MP wb_[h[`𓋍ڂ
Check_EMS	equ	1	; EMS  install Ă邩mF
USE_frag_mem	equ	1	; Program[page-dirԂ̋󂫃gp
USE_XMS20	equ	0	; XMS Ver2.0ɂΉiʏsvj

_TITLE_disp	equ	1	; ^Cg\
_Verbose	equ	0	; 璷ȕ\
_see_PATH386	equ	1	; ϐ PATH386 QƂ
_see_PATH	equ	0	; ϐ PATH QƂ

_reset_CRTC	equ	3	; [TOWNS] I CRTC/VRAM ̏ݒ
				;	0 = ,     1 = , 
				;	2 = CRTĈݏ, 3 = 
_check_MACHINE	equ	1	; ȈՋ@픻ʂs

SAVE_8259A	equ	1	; n[hEFA荞݃}XNIɕ
Rec_Real_Vec	equ	1	; A[h荞݃xN^̕

;==============================================================================
; General define
;==============================================================================
EXP_EXT		equ	'.exp'	;⊮gq

F386ERR		equ	0fch	;Free386G[ĨG[R[h
CPU_Fault	equ	0fdh	;CPU fault

Memory_page_max	equ	40000h	;1GB max

V86_stack_size	equ	 200h	;=byte / V86 [hX^bNTCY 
PM_stack_size	equ	 400h	;=byte / veNg[hX^bNTCY
VCPI_stack_size	equ	  80h	;VCPI call(to V86)̂ݎgpX^bNTCY

ISTK_nest_max	equ	4	;CPU[h؂ւlXg
ISTK_size	equ	400h	;[h؂芷X^bNTCYilXgΉj
INT_BUF_size	equ	800h	;V86Protectԃf[^nzTCYilXgΉj
INT_BUF_sizebits equ	10	;̃rbg
INT_RWBUF_size	equ	4000h	;t@Co͐pobt@TCY

work_size	equ	200h	;ėp[NTCY / min 200h

_POOL_mem_pages	equ	8	;y[WÔ߂ɗ\񂷂郁y[W
_CALLBUF_sizeKB	equ	4	;CALLobt@ƂĎgpDOSTCY (KB)
_REAL_mem_pages	equ	4	;vOspA (page)

Unit_of_MEM	equ	400000h	;AhX̊蓖ĒP(byte)
MIN_heap_mem	equ	200000h	;ŏq[vjAAhX

int_21h_MAXF	equ	80h	;int 21h ̃t@NVԍ̍ől +1
DOS_Ext_MAXF	equ	18h	;DOS-Extendergt@NV̍őfuncԍ+1

V86_flags	equ	0000h	;V86 [h̃tOl

F386_INT	equ	9ch	;Free386 ƎINTԍ
F386_MAX_func	equ	20h	;Free386 ƎINT̍őfuncԍ+1


;==============================================================================
;ZN^֌W̒萔
;==============================================================================
NULL_sel	equ	00h	;kZN^
VCPI_sel	equ	68h	;VCPI pZN^l 68h `78h

GDTsize		equ	200h	;GDTԍ 0`1f8h ܂
LDTsize		equ	200h	;LDTԍ 4`1fch ܂
IDTsize		equ	800h	;IDT̑傫 int 0-0ffh (Œ)
TSSsize		equ	80h	;fBtHgTSS (68h Byte ȏ)

LDT_sel		equ	28h	;LDTZN^l
LDT_RW		equ	30h	;LDTANZXpZN^
GDT_RW		equ	38h	;GDTANZXpZN^
IDT_RW		equ	50h	;IDTANZXpZN^
TSS_sel		equ	80h	;TSSZN^
TSS_RW		equ	88h	;TSSANZXpZN^

ALLMEM_sel	equ	40h	;SZN^
DOSMEM_sel	equ	60h	;DOS ԂZN^
DOSMEMsize	equ	110000h	;1MB + 64KB (HMA)

F386_cs		equ	08h	;free386p CSZN^
F386_ds		equ	10h	;free386p DSZN^
F386_cs2	equ	18h	;free386p CSZN^ / 286݊
F386_ds2	equ	20h	;free386p DSZN^ / 286݊

PSP_sel1	equ	24h	;PSP̈
PSP_sel2	equ	04h	;
DOSENV_sel	equ	2ch	;DOS ϐ̈
DOSMEM_Lsel	equ	34h	;DOS  (in LDT)

;==============================================================================
;Œ萔
;==============================================================================

Real_Vectors	equ	100h	;A[h̊荞݃xN^

;------------------------------------------------------------------------------
;TSS offset
;------------------------------------------------------------------------------

TSS_SS0_off	equ	08h	;׃0 X^bNl
TSS_ESP0_off	equ	04h	;

;==============================================================================
;@ʂ̒萔
;==============================================================================
;------------------------------------------------------------------------------
;for FM-TOWNS
;------------------------------------------------------------------------------
%if TOWNS

MACHINE_CODE	equ	20h	;TOWNSV[Y

%define	MACHINE_STRING	'FM TOWNS'
%define	Free386_API	'f386_fmt.api'	;@ŗLAPĨt@C

INIT_KEY_BIOS	equ	1	;I key-BIOS 

TBIOS_cs	equ	110h	;T-BIOS  code ZN^
TBIOS_ds	equ	118h	;T-BIOS  data ZN^

NSDD_max	equ	20	;NSD Driver̍őΉi64܂Őݒ\j
NSDD_stra_adr	equ	06h	;strategy Gg[̂ItZbg
NSDD_intr_adr	equ	08h	;interruptGg[̂ItZbg
NSDD_sleep	equ	0c0h	; intr/sleep  request
NSDD_wakeup	equ	0c1h	; intr/wakeup request

enable_INTR	equ	1	;veNg[hł̊荞݂
INTR_MASTER	equ	40h	;}X^Fn[hEFA荞ݐ擪
INTR_SLAVE	equ	48h	;X[u
I8259A_ISR_M	equ	00h	;T[rXWX^
I8259A_ISR_S	equ	10h	;
I8259A_IMR_M	equ	02h	;}XNWX^
I8259A_IMR_S	equ	12h	;

%endif

;------------------------------------------------------------------------------
;for PC-9821/9801
;------------------------------------------------------------------------------
%if PC_98

MACHINE_CODE	equ	10h	;PC-98x1 V[Y

%define	MACHINE_STRING	'PC-9801/9821'
%define	Free386_API	'f386_98.api'	;@ŗLAPĨt@C

VRAM_16padr	equ 0E00A8000h	;16FVRAM zu镨AhX
VRAM_CGW	equ 0E00A4000h	;CGW zu郊jAAhX
VRAM_TEXT	equ 0E00A0000h	;CGW zu郊jAAhX
STOP_GVRAM	equ	0	;IŃOtBbNʂ̕\off

enable_INTR	equ	1	;veNg[hł̊荞݂
INTR_MASTER	equ	08h	;}X^Fn[hEFA荞ݐ擪
INTR_SLAVE	equ	10h	;X[u
I8259A_ISR_M	equ	00h	;T[rXWX^
I8259A_ISR_S	equ	08h	;
I8259A_IMR_M	equ	02h	;}XNWX^
I8259A_IMR_S	equ	0ah	;

%endif

;------------------------------------------------------------------------------
;for PC/AT
;------------------------------------------------------------------------------
%if PC_AT

MACHINE_CODE	equ	30h	; PC/AT

%define	MACHINE_STRING	'PC/AT'
%define	Free386_API	'f386_at.api'	; API file

VESA_buf_sel	equ	148h	; VESA-BIOS buffer selector
VESA_buf_size	equ	1	; VESA-BIOS buffer size (page / 1=4kb)
VESA_call_adr	equ	0ffc0h	; VESA-BIOS call u VESA_cs AhX
				; call code 肫Ȃ듮삷

VESA_cs		equ	150h	; VESA-BIOS code selector
VESA_ds		equ	158h	; VESA-BIOS data selector (cs alias)
VESA_ds2	equ	160h	; VESA-BIOS data selector 2 (needs 600h)
VESA_A0		equ	168h	; VESA-BIOS selector A0000h (64kb)
VESA_B0		equ	170h	; VESA-BIOS selector B0000h (64kb)
VESA_B8		equ	178h	; VESA-BIOS selector B8000h (32kb)

VRAM_padr	equ 0e6000000h	; VRAM physical address
VRAM_size	equ	200h	; size=8MB / [page unit] ex)100h=4MB
VRAM_sel	equ	120h	; VRAM selector (Change with at.asm)

enable_INTR	equ	1	; Enable hardware interrrupt
INTR_MASTER	equ	 08h	; master
INTR_SLAVE	equ	 70h	; slave
I8259A_ISR_M	equ	 20h	; service register
I8259A_ISR_S	equ	0a0h	;
I8259A_IMR_M	equ	 21h	; mask register
I8259A_IMR_S	equ	0a1h	;

%endif

;------------------------------------------------------------------------------
;setting check
;------------------------------------------------------------------------------

%if (TOWNS + PC_98 + PC_AT) >1
%error You must select from "for_TOWNS, for_PC98, fot_AT", or no select.

;------------------------------------------------------------------------------
;for General DOS machine
;------------------------------------------------------------------------------

%elif (TOWNS + PC_98 + PC_AT) = 0

MACHINE_CODE	equ	00h

%define	MACHINE_STRING	'MS-DOS'
%define	Free386_API	'f386_all.api'	; dummy

enable_INTR	equ	0	; Do not use hardware interrupt
INTR_MASTER	equ	0f0h	; dummy
INTR_SLAVE	equ	0f0h	; dummy

%endif

