;------------------------------------------------------------------------------
;F386sub.asm	sub-routine for Free386
;------------------------------------------------------------------------------
;[TAB=8]
;	Author kattyo@abk / nabe@abk ([`ɂ)
;
;------------------------------------------------------------------------------

%include	"nasm_abk.h"		;NASM pwb_t@C
%include	"f386def.inc"		;
%include	"macro.asm"		;}N

%include	"free386.inc"		;OϐQ
%include	"f386seg.inc"		;
%include	"start.inc"		;

;------------------------------------------------------------------------------

	;WX^_v
	public	register_dump		;safe
	public	register_dump_fault	;safe
	public	dump_err_code
	public	dump_orig_esp
	public	dump_orig_ss
%if INT_HOOK
	public	register_dump_from_int	;safe
%endif
	public	eax2hex

	public	searchpath		;t@C̃pXT[`
	public	load_exp		;exp t@C̃[h
	public	run_exp			;exp t@C̎s

;******************************************************************************
;R[h
;******************************************************************************
;
;##############################################################################
;stack dump
;	This is PDS.
;	made by @ABK  2000/07/24
;##############################################################################
;
; 2001/01/18	Free386 ւ̑gݍ		(by nabe@abk)
; 2001/02/06	dl̊Ⴂ & 	(by nabe@abk)
;
;
segment	text public align=16 class=CODE use16
BITS	32
;------------------------------------------------------------------------------
;WX^_v\
;------------------------------------------------------------------------------
;;	mov		eax, 0dh		; Oԍ
;;	mov		ebx, offset dmy_tbl	; ne[u
;;
%imacro	to_hex	1
	mov	edx,offset %1
	call	eax2hex
%endmacro

%if INT_HOOK
;------------------------------------------------
register_dump_from_int:		;safe
;------------------------------------------------
	push	ds
	push	eax
	;
	; callAhXexception numberɎg
	; com̎dl, 100h 菬Ƃ͖
	;
	;stack
	;	+18h	eflags
	;	+14h	cs
	;	+10h	eip
	;	+0ch	int number
	;	+08h	caller (or exception number)
	;	+04h	ds
	;	+00h	eax
	;
	push	d F386_ds
	pop	ds
	;
	; Free386 internal call ignore
	;
%if !INT_HOOK_F386
	cmp	d [esp+14h], F386_cs
	jz	short .no_dump
%endif
	;
	; int 21h, ah=09h ͖
	;
	cmp	b [esp+0ch], 21h
	jnz	short .not_int21
	cmp	ah, 09h
	jz	short .no_dump

.not_int21:
	; Int = ɏ
	mov	eax, [blue_int_str]
	mov	[regdump_msg], eax

	call	register_dump_fault	;safe

	; Err = ɖ߂
	mov	eax, [blue_err_str]
	mov	[regdump_msg], eax
.no_dump:
	push	d [esp+18h]	; eflags
	popf
	pop	eax
	pop	ds
	ret
%endif

	align	4
;------------------------------------------------
register_dump:		;safe
;------------------------------------------------
	pushf
	push	cs
	push	eax	; EIP dummy
	push	d [cs:dump_err_code]
	push	d 100h	; Exception number
	push	ds
	push	eax
	mov	eax, F386_ds
	mov	 ds, eax
	mov	eax,[esp+1ch]	; caller
	mov	[esp+10h],eax
	mov	d [dump_err_code], -1

	call	register_dump_fault	;safe

	pop	eax
	pop	ds
	add	esp, 10h
	popf
	ret

	;stack
	;	+1ch	eflags
	;	+18h	cs
	;	+14h	eip
	;	+10h	error code
	;	+0ch	exception number
	;	+08h	ds
	;	+04h	eax
	align 4
;------------------------------------------------
register_dump_fault:	;safe
;------------------------------------------------
	; WX^ۑ, dsݒςŌĂяo
	push	edx
	push	ecx
	push	ebx
	push	eax

	mov	eax, [esp+14h]
	to_hex	blue_eax
	mov	eax, [esp+04h]
	to_hex	blue_ebx
	mov	eax, [esp+08h]
	to_hex	blue_ecx
	mov	eax, [esp+0ch]
	to_hex	blue_edx

	mov	eax, esi
	to_hex	blue_esi
	mov	eax, edi
	to_hex	blue_edi
	mov	eax, ebp
	to_hex	blue_ebp

	mov	eax, [esp+20h]
	to_hex	blue_errorcode
	mov	eax, [esp+24h]
	to_hex	blue_eip
	mov	eax, [esp+28h]
	to_hex	blue_cs

	mov	eax, [esp+18h]
	to_hex	blue_ds
	mov	eax, es
	to_hex	blue_es
	mov	eax, fs
	to_hex	blue_fs
	mov	eax, gs
	to_hex	blue_gs

	mov	eax, [dump_orig_ss]
	mov	d [dump_orig_ss], -1
	cmp	eax, -1
	jz	short .current_ss

	to_hex	blue_ss
	mov	eax,[dump_orig_esp]
	to_hex	blue_esp
	jmp	short .end_ss
.current_ss:
	mov	eax, esp
	add	eax, b 30h
	to_hex	blue_esp
	mov	eax, ss
	to_hex	blue_ss
.end_ss:

	mov	eax, cr0
	to_hex	blue_cr0
	mov	eax, cr2
	to_hex	blue_cr2
	mov	eax, cr3
	to_hex	blue_cr3

	mov	eax, [esp + 2ch]	; eflags
	mov	edx, offset blue_flags +1

	test	ah, 004h	; OF
	setnz	bl
	or	bl, '0'
	mov	[edx],bl

	test	ah, 002h	; DF
	setnz	bl
	or	bl, '0'
	mov	[edx + 3*1],bl

	test	al, 040h	; Zero
	setnz	bl
	or	bl, '0'
	mov	[edx + 3*2],bl

	test	al, 020h	; Zero
	setnz	bl
	or	bl, '0'
	mov	[edx + 3*3],bl

	test	al, 001h	; Carry
	setnz	bl
	or	bl, '0'
	mov	[edx + 3*4],bl

	to_hex	blue_eflags

	;CPUOɂĂяoH
	mov	ebx, offset regdump_msg
	mov	eax, [esp + 1ch]
	cmp	eax, 0ffh
	ja	.no_exception

	mov	dl, [err_max]
	cmp	al, dl
	jbe	.exp1
	mov	al, dl
.exp1:
	movzx	ecx, b [err_size]
	mul	ecx	; edx broken
	lea	ebx, [err_00 + eax]
	mov	edx, offset blue_intno
.loop:
	mov	al, [ebx]
	mov	[edx], al
	inc	ebx
	inc	edx
	loop	.loop
	mov	ebx, offset blue_screen
	jmp	short .print

.no_exception:
	cmp	d [esp+20h], -2
	jne	.print
	PRINT	string_return
	PRINT	offset regdump_ds
	PRINT	string_crlf
	jmp	short .exit

.print:
	PRINT	ebx
.exit:
	pop	eax
	pop	ebx
	pop	ecx
	pop	edx
	ret

;================================================
;convert to hex
;================================================
; EAX  [EDX] ւPUiƂĊi[
	align 4
eax2hex:
	mov	bl,[edx+4]
	cmp	bl,'_'
	jz	.loop
	shl	eax, 16
.loop:
	mov	ebx, eax
	shr	ebx, 28
	mov	 cl, [hexstr + ebx]
	mov	[edx], cl
	inc	edx
	shl	eax, 4

	mov	bl, [edx]
	cmp	bl, ' '
	jz	.end
	cmp	bl, ':'
	jz	.end
	cmp	bl, 'h'
	jz	.end
	cmp	bl, 13
	jz	.end

	cmp	bl, '_'
	jnz	.loop
	inc	edx
	jmp	short .loop
.end:
	ret


;##############################################################################
;findpath  -  search PATH
;	This is PDS.
;	made by @ABK  2000/07/24
;##############################################################################
;
; 2001/01/31	Free386 ւ̑gݍ (by nabe@abk)
;
;------------------------------------------------------------------------------
;{
;------------------------------------------------------------------------------
;
; searchpath
;
;in:
;	[esi]	vO
;	[ebx]	ϐ
;ret:
;	eax	0=
;		  [edi]	ʃvO
;		1=vOt@CȂ
;		2=Y閼O̊ϐȂ
;
	align	4
searchpath:
		;ŏɃJgfBNgT
		mov	edx, esi		; t@C
		call	is_file_exist
		jc	.search_current_add_EXP
		mov	edi, esi
		mov	eax, 0
		ret


	align	4
.search_current_add_EXP:
		push	esi
		mov	ecx, 0
.search_current_add_EXP_strcpy:
		mov	al, [esi]
		mov	[nowpath + ecx], al
		inc	esi
		inc	ecx
		or	al, al
		jnz	.search_current_add_EXP_strcpy
		
		pop	esi
		
		mov	d [nowpath + ecx - 1], '.EXP'
		mov	b [nowpath + ecx + 3], 0
		mov	edx, offset nowpath
		call	is_file_exist
		jc	.search_path
		
		mov	edi, offset nowpath
		mov	eax, 0
		ret
		
.search_path:
		call	___getenv_2
		or	eax, eax
		jz	.ng_env_notfound

.search_next:
		call	getnextpath_
		or	eax, eax
		jz	.no_program

		call	add_progname_
		
		mov	edx, offset nowpath	; t@C
		call	is_file_exist		; ݌
		
		jc	.add_EXP
		
		mov	edi, offset nowpath
		mov	eax, 0
		ret
		
.add_EXP:
		mov	edx, offset nowpath
		mov	eax, [nowpath_len]
		mov	byte [edx + eax], '.'
		
;	push	esi
;	mov	esi, edx
;	call	print_sz
;	pop	esi
		
		call	is_file_exist
		
		jc	.not_found
		
		mov	edi, offset nowpath
		mov	eax, 0
		ret
.not_found:
		jmp	.search_next

.no_program:
		mov	eax, 2
		ret

.ng_env_notfound:
		mov	eax, 1
		ret

; ϐȂ
.ng_notfound:
		mov	eax, 2
		ret


;t@CJ邩
;
;in:
;	[edx]	t@C
;ret:
;	Cy	0 t@C
;		1 t@CȂ
;
is_file_exist:
		push	eax
		push	ebx
		
		mov	ah, 03Dh		; File/Device open
		mov	al, 000b		; ǂݍ݂̂
		int	021h
		jnc	.file_found

		jmp	.ret

.file_found:
		mov	bx, ax		; BX=nh
		mov	ah, 03Eh	; File/Device Close
		int	21h
		jmp	.ret
.ret:
		pop	ebx
		pop	eax
		ret

;
; ϐ擾
;
;in:
;	[ebx]		擾ׂϐ
;ret:
;	eax		 (0=sAȊO=)
;	edi		ʂ̊ϐl ('='E)
;
___getenv_2:
		push	esi
		push	edi
		
		mov	ax, 02Ch
		mov	es, ax		; 02Ch = ϐւ̃ZN^
		mov	edi, 0		; ϐZN^ItZbg[
		
		;ϐ񒷂擾
		mov	ecx, -1
		mov	esi, ebx
.envlencnt:
		inc	ecx
		cmp	byte [esi + ecx], 00h
		jnz	.envlencnt
		mov	eax, ecx
		

	align	4
.loop:
		mov	ecx, eax		; ECXEAX(ϐ)
		mov	esi, ebx		; ESIEBX(ϐ)
		
		cmp	byte [es:edi], 00h	; ϐXgI[H
		jz	.ng			; I[ȂI
		cld
		
	repz	cmpsb				; 񌟍
		
		jecxz	.ok
		
	align	4
.loop2:
		cmp	byte [es:edi], 00h	; ϐSĎgĂ
		pushfd				; Ȃ̂Ō(
		inc	edi			; ϐ܂ŃXLbv
		popfd				; ˂Ă)
		jnz	.loop2			;
		jmp	.loop
.ng:
		mov	eax, 0
		jmp	.ret
.ok:
		cmp	byte [es:edi], '='	; CR[Lǂ '='H
		jnz	.loop2
		
		mov	eax, 1
		inc	edi
		mov	[nowenv], edi
		
		jmp	.ret
.ret:
		pop	edi
		pop	esi
		ret

;
;getnextpath	 PATH vf𓾂
;
;FA:\DOS;A:\TOOL;A:\GAME;A:\TC\BIN'\0'
;                              
;
;in:
;	ɂȂ
;ret:
;	eax	0=s
;	nowpath	ꂽfBNg
;
getnextpath_:
		push	esi
		
		mov	ecx, 0
		mov	esi, [nowenv]
		mov	ax, 02Ch
		mov	es, ax
		
		cmp	b [es:esi], 0
		jz	.no_more
		
.cpy_to_buf:
		mov	al, [es:esi]
		mov	b [nowpath + ecx], al
		inc	esi
		inc	ecx
		
		cmp	al, 00h
		jz	.cpy_to_buf_end_zero
		cmp	al, ';'
		jnz	.cpy_to_buf
		jmp	.cpy_to_buf_end
		
.cpy_to_buf_end_zero:
		dec	esi
.cpy_to_buf_end:
		dec	ecx
		mov	b [nowpath + ecx], 00h
		mov	[nowenv], esi
		mov	[nowpath_len], ecx
		
		pop	esi
		mov	eax, 1
		ret
.no_more:
		mov	eax, 0
		pop	esi
		ret

;
;vOt
;
;
;
	align	4
add_progname_:
		push	edi
		push	esi
		
		mov	edi, offset nowpath
		add	edi, [nowpath_len]
		
		cmp	d [nowpath_len], 0
		jz	.loop
		cmp	b [edi - 1], '\'
		jz	.loop
		mov	b [edi], '\'
		mov	b [edi + 1], 0
		inc	edi
		
	align	4
.loop:
		mov	al, [esi]
		mov	[edi], al
		inc	esi
		inc	edi
		or	al, al
		jnz	.loop

		mov	d [edi], 'EXP'
		dec	edi
		sub	edi, offset nowpath
		mov	d [nowpath_len], edi

		;pX̕\
		;;mov	esi, nowpath
		;;call	print_sz

		pop	esi
		pop	edi
		ret


;##############################################################################
;##############################################################################
; under is presented by nabe@abk.
;/////////////////////////////////////////////////////////////////////////////
;.EXP t@C̃[h
;/////////////////////////////////////////////////////////////////////////////
;	2001/02/15	F386prot.asm ړ
;
;	IN	[edx]	t@C (ASCIIz)
;		[esi]	obt@AhX(min 200h)
;
;	Ret	Carry = 0 / [h
;		fs	[hvO cs
;		gs	[hvO ds
;		edx	[hvO EIP
;		ebp	[hvO ESP
;
;		Carry = 1 / [hs
;		al	G[R[h (F386G[R[hƓ)
;
;------------------------------------------------------------------------------
;EXP t@C̃[h
;------------------------------------------------------------------------------
	align	4
load_exp:
	push	ds			;Ōɐςނ
	mov	es,[esp]		;es ɐݒ

	;/// t@CI[v ///
	;mov	edx,[t@C]	;t@C ASCIIz
	mov	ax,3d00h		;file open(read only)
	int	21h			;dos call
	jc	NEAR error_exit0	;Cy=1 ȂI[vG[

	mov	ebx,eax			;bx <- file handlԍ
	mov	[file_handle],eax	;ɂL^

	;
	;wb_[h
	;
	mov	edx,esi			;[NAhX
	mov	ecx,200h		;ǂݍރoCg
	mov	ah,3fh			;file read ->ds:edx
	int	21h			;dos call
	jc	NEAR error_exit1	;Cy=1 Ȃ烊[hG[

	;
	;wb_
	;
	mov	eax,[esi]
	cmp	eax,00013350H	;P3 `['P3']Etbgf[w (0001)]
	jne	NEAR check_MZ	;P3 łȂ MZwb_mF (jmp)

	;
	;KvȃZo
	;
	mov	eax,[esi+74h]	;[hC[W̑傫ivÕTCYj
	add	eax,[esi+56h]	;t@ČɊ蓖Ă郁̍ŏ
	add	eax,[esi+5eh]	;x[XAhXZ
	add	eax,     0fffh	;4KB PʂŃ̂Œ[Jグ
	and	eax,0fffff000h	;4KB Pʂ
	mov	[5ch],eax	;PSP ɋL^ /ŒKvȃZOgTCY[byte]

	mov	ecx,[esi+5ah]	;t@ČɊ蓖Ă郁̍ő
	add	ecx,[esi+74h]	;[hC[W̑傫ivÕTCYj
	jnc	.step		;lI[o[ĂȂ jmp
	mov	ecx,0fffff000h	;ől
.step:	add	ecx,     0fffh	;4KB PʂŃ̂Œ[Jグ
	shr	ecx,12		;4KB Pʂ

	push	esi
	mov	esi,[esi+5eh]		;x[XAhX
	call	make_cs_ds		;cs/ds 쐬ƃm
	pop	esi
	jc	NEAR not_enough_memory	;G[Ȃ烁s

	;
	;ʃ`FbN
	;
	mov	ebx,[60h]		;ۂɊ蓖Ă [byte]
	mov	eax,[5ch]		;PSP ɋL^ / ŒKvȃ [byte]
	cmp	ebx,eax			;lr
	jb	NEAR not_enough_memory	;Ȃ烁s

	sub	ebx,[esi+74h]		;[hC[W̑傫
	sub	ebx,[esi+5eh]		;x[XItZbgTCY
	mov	[64h],ebx		;q[vʂ PSPɋL^

	;
	;[hvÕX^bNƎsJnAhXL^
	;
	mov	eax,[esi + 62h]	;X^bN|C^
	mov	ebx,[esi + 68h]	;sJnAhX
	mov	[data3],eax	;esp
	mov	[data4],ebx	;eip

	;
	;vO[h
	;
	mov	ebx,[file_handle]	;ebx <- t@Cnhԍ[h
	mov	 dx,[esi + 26h]		;vO܂ł̃t@CItZbg
	mov	 cx,[esi + 28h]		; bit 31-16
	mov	ax,4200h		;t@C擪|C^ړ
	int	21h			;dos callifile pointer = cx:dxj
	jc	error_exit2		;Cy=1 Ȃ G[

	mov	ecx,[esi + 2ah]		;ǂލރTCYivOTCYj
	mov	edx,[esi + 5eh]		;ǂݍސ擪(ds:edx)
					;+5eh ɂ"x[XAhX"
	mov	 ds,[Load_ds]		;[hZN^l[h

	;
	;-PACK ŃN PACK Ă邩`FbN
	;
	mov	eax,[es:esi+72h]	;wb_ tOl
	test	al,01h			;bit 0  check

	push  d (offset sl_un_pack_ret)	;call ̖߂胉x
	jnz	NEAR exp_un_pack_fread	;PACK Ȃt@Cǂݍ

	add	esp,byte (4)		;X^bN(߂胉x)


EXP_file_read:		;MZ wb_[hĂ΂
	;
	;t@C[h
	; ds:edx  ecx oCgǂݍ
	;
	mov	ah,3fh			;file read
	int	21h			;DOS R[
	jc	error_exit2		;L[ 1 Ȃ [hG[


	align	4
sl_un_pack_ret:
	mov	ah,3eh			;t@CN[Y
	int	21h			;dos R[

	pop	ds
	mov	ebp,[data3]		;esp
	mov	edx,[data4]		;eip
	mov	 fs,[Load_cs]		;cs
	mov	 gs,[Load_ds]		;ds
	clc				;L[NA
	ret


	align	4
error_exit2:
	mov	ds,[esp]		;X^bNgbv DS 
error_exit1:
	mov	ebx,[file_handle]	;ebx <- t@Cnhԍ[h
	mov	ah,3eh			;t@CN[Y
	int	21h			;dos call
error_exit0:
	mov	al,28h			;File read error
	pop	ds
	stc				;L[Zbg
	ret

	align	4
ftype_error:
	mov	cl,24h			;Ήt@C`
	jmp	short fclose_end	;t@CN[YĂI

	align	4
not_enough_memory:
	mov	cl,23h			;s
fclose_end:
	pop	ds

	mov	ebx,[file_handle]	;ebx <- t@Cnhԍ[h
	mov	ah,3eh			;t@CN[Y
	int	21h			;dos call

	mov	al,cl			;al = G[R[h
	stc				;L[Zbg
	ret



;----------------------------------------------------------------------
;MZ wb_ EXP t@C̃[h
;----------------------------------------------------------------------
;;	mov	eax,[esi]
;;	cmp	eax,00013350H	;P3 `['P3']Etbgf[w (0001)]
;;	jne	NEAR check_MZ	;P3 łȂ MZwb_mF (jmp)
;
	;////////////////////////////////////////////////////
	;MZ(MP) wb_ɑΉȂꍇ
	;////////////////////////////////////////////////////
%if (USE_MZ_EXP = 0)
	align	4
check_MZ:
	jmp	short ftype_error	;MZ wb_ɑΉȂ
%else

	;////////////////////////////////////////////////////
	;MZ(MP) wb_[h[`
	;////////////////////////////////////////////////////
	align	4
check_MZ:
	cmp	ax,'MP'		;MZ(MP) wb_?
	jne	ftype_error	; Ή`

	;
	;KvȃZo
	;
	;+02h   file size & 511
	;+04h  (file size + 511) >> 9   / thanks to Mamiya (san)
	;
	mov	ebp,eax		;ebp = eax
	shr	ebp,16		;+02 w "t@CTCY / 512" ̗]
	movzx	eax,w [esi+04h]	;+04 w "512 byte Pʂ̃ubN"
	movzx	edx,w [esi+08h]	;+08 w "wb_  TCY / 16"
	movzx	ecx,w [esi+0ah]	;+0A w "q[v̍ŏ / 4KB"
	shl	eax,9		;512{
	shl	edx,4 		; 16{
	shl	ecx,12		;4K(4096){

	or	eax,ebp		;eax = (512 byteubN)*512 + 511ȉ̒[
	test	ebp,ebp		;ebp = 0 ?
	jz	.step		;0 Ȃ jmp
	sub	eax,512		;[Ȃ 512 byte  / eax = file size

.step:
	sub	eax,edx		;eax = vOC[WTCY
	mov	ebp,eax		;[hC[WTCYۑĂ
	xchg	eax,ecx		;eax=ŒKvȃ ecx=vOTCY

	;FȉAt@C|C^ړ܂ edx,ebp j󂵂Ȃ

	movzx	ebx,w [esi+0ch]	;+0C w "q[v̍őv / 4KB"
	add	ecx,0fffh	;4KB؏グ
	shr	ecx,12		;/4KB
	add	ecx,ebx		;ecx = őv
	;/// ecx = őv
	push	esi
	xor	esi,esi			;x[XAhX = 0
	call	make_cs_ds		;cs/ds 쐬ƃm
	pop	esi
	jc	not_enough_memory	;G[Ȃ烁s

	;
	;ʃ`FbN
	;
	mov	ebx,[60h]		;ۂɊ蓖Ă [byte]
	mov	[5ch],eax		;PSP ɋL^ / ŒKvȃ [byte]
	cmp	ebx,eax			;lr
	jb	not_enough_memory	;Ȃ烁s

	sub	ebx,ebp			;[hC[W̑傫
	mov	[64h],ebx		;PSPɋL^ / q[v [byte]

	;
	;X^bN exp ̂̂ɕύX
	;
	mov	eax,[esi + 0eh]	;X^bN|C^
	mov	ebx,[esi + 14h]	;sJnAhX
	mov	[data3],eax	;esp
	mov	[data4],ebx	;eip

	;
	;ȉAP3 ̃Rs[
	;
	mov	ebx,[file_handle]	;ebx <- t@Cnhԍ[h
	xor	ecx,ecx			;ecx = 0
	;mov	edx,---		;	;edx = vOC[W܂ł offset
	mov	ax,4200h		;t@C擪|C^ړ
	int	21h			;DOS callifile pointer = cx:dxj
	jc	NEAR error_exit2	;Cy=1 Ȃ G[

	mov	ecx,ebp			;ǂލރTCYivOTCYj
	xor	edx,edx			;ǂݍސ擪(ds:edx)

	mov	edi,[Load_ds]		;[hZN^l[h
	mov	 ds,edi			;

	jmp	EXP_file_read		;ۂ̓ǂݍݏ (P3 Header Ƌ)
%endif


;======================================================================
;EXP  PACK nȂt@C[hTu`[ (P3wb_)
;======================================================================
;
;	special thanks to PEN@CL i񋟁j
;
;	in	   ebx = t@Cnhԍ
;		ds:edx = t@Cǂݍރʒu
;		   ecx = t@CǂݍރTCY
;
;		es:esi = [N(200h byte)
;
	align	4
exp_un_pack_fread:
	push	ebp
	push	edi

	mov	ebp,ecx		;ebp = ǂݍރoCg

	;
	;ZOgWX^ dses ̌
	;
	mov	eax,es
	mov	ecx,ds
	mov	 ds,eax
	mov	 es,ecx
	mov	[data1],eax	;̃vO
	mov	[data2],ecx	;ǂݍݐ

	;
	;ɂ ds ̃ZOg悤ɂȂ
	;
	mov	edi,edx			;edi <- t@Cǂݍݐ
	mov	edx,esi			;edx <- [N
	mov	[data0],esi		;ėpϐɈꎞIɋL


	align	4
exp_up_loop:	;*** [vX^[g ****************************
	;
	;ds:edx = [N
	;es:edi = t@C[ḧ
	;   ebx = t@Cnhԍ
	;   ebp = cǂݍ݃oCg

	test	ebp,ebp			;c byte 
	jz	exp_up_fread_eof	;if 0 jmp I

	;
	; 2 byte [h
	;
	mov	ecx,2			;2 byte
	sub	ebp,ecx			;ebp = cTCY
	mov	ah,3fh			;file read
	int	21h			;DOS R[
	jc	short exp_up_fread_err	;L[΃[hG[
	test	ax,ax			;ax mF
	jz	short exp_up_fread_eof	;0 Ȃ EOF ł

	xor	eax,eax			;eax ̏16bit NA
	mov	 ax,[edx]		;eax <- ǂݍ񂾃f[^
	bt	eax,15			;rbg 15 mF
	jc	short pack_length	;1 ȂpbNĂ

	;
	;pbNĂȂ$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	;
	mov	edx,edi			;edx <- vO[ḧ
	mov	ecx,eax			;ecx = ǂݍރoCg
	sub	ebp,eax			;ebp = cTCY
	add	edi,eax			;[hoCgvO[ḧ
					; ̃AhXXebv

	mov	 ds, [data2]		;ds = t@C[ḧ

	;
	;ds:edx = vO[ḧ
	;
	mov	ah,3fh			;file read
	int	21h			;DOS R[
	jc	short exp_up_fread_err	;L[΃[hG[

	mov	 ds, [cs:data1]		;̃vO ds
	mov	edx, [data0]		;[NGAItZbg߂
	;
	;ds:edx [N̈ɕ
	;

	jmp	short exp_up_loop	;[v***********



	;
	;/// [`I //////////////////////////////////////
	;
	align	4
exp_up_fread_eof:	;t@CŌ܂œǂŁA
	;
	;ZOgWX^ dses ɖ߂
	;
	mov	 es,[data1]	;̃vO
	mov	 ds,[data2]	;[ḧ

	pop	edi
	pop	ebp
	ret

	;
	;/// t@Cǂݍݎ̃G[ ////////////////////////
	;
	align	4
exp_up_fread_err:
	pop	edi
	pop	ebp
	add	esp,4			;߂胉x
	jmp	error_exit2		;G[ɂEo
	;///////////////////////////////////////////////////////



	align	4
	;
	;PACK Ă $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	;
pack_length:
	and	eax,7fffh	;rbg15  0 ɂ
	mov	esi,eax		;esi ɒlL

	dec	ebp			;ebp = coCg
	mov	ecx,1			;1 byte
	mov	ah,3fh			;file read
	int	21h			;DOS R[
	jc	short exp_up_fread_err	;L[΃[hG[

	xor	eax,eax			;eax NA
	mov	al,[edx]		;ǂݍ񂾒lmF
	test	al,al			;and al,al
	jnz	short str_length	;0 łȂΕ̌JԂk

	;
	;NULL R[h̃OXkł
	;
	mov	ecx,esi			;woCg
	rep	stosb			;NULL WJ ->es:edi

	jmp	exp_up_loop		;[v***********



	align	4
	;
	; PACK Ă $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
	;
str_length:
	mov	cl,al			;ecx <- JԂ̒
	sub	ebp,eax			;ebp = coCg
	mov	ah,3fh			;file read
	int	21h			;DOS R[
	jc	short exp_up_fread_err	;L[΃[hG[

	push	ebx			;ebx ۑ
	xor	ebx,ebx			;ebx NA

	mov	ah,cl			;ah <- ̒
	mov	ecx,esi			;Rs[oCg

	align	4
str_length_loop:
	mov	al,[edx + ebx]		;񃍁[h
	inc	bl			;ItZ	bgXebv
	cmp	bl,ah			;Ɣr
	je	short strl_lp_offsetc	; 0 ȂItZbgNA

	mov	[es:edi],al		;1 byte 
	inc	edi			;AhXXV
	loop	str_length_loop		;ecx JE^ 0 ɂȂ܂Ń[v

	pop	ebx
	jmp	exp_up_loop		;[v***********

	align	4
strl_lp_offsetc:	;ebx  0 Ƀ[v
	xor	bl,bl			;ebx = 0

	mov	[es:edi],al		;1 byte 
	inc	edi			;AhXXV
	loop	str_length_loop		;ecx JE^ 0 ɂȂ܂Ń[v

	pop	ebx
	jmp	exp_up_loop		;[v***********


;======================================================================
;vO[hZN^쐬Tu`[
;======================================================================
;	ecx	vő(page)
;	esi	ǂݍݐ炷(P3wb_ -offset IvV)
;
;Ret	Cy=0 
;		ۂ̊蓖ė(byte) PSP  [60h] ɋL^
;		Load_cs, Load_ds Ƀ[hpZN^ cs/ds L^
;	Cy=1 s
;
	align	4
make_cs_ds:
	push	eax
	push	ecx
	push	edx
	push	esi
	push	ebp

	mov	ebp,[free_RAM_pages]	;󂫃Ɣr
	add	ebp,[DOS_mem_pages]	;DOS

	mov	edx,esi			;ǂݍ݃x[X
	shr	edx,12			;pagePʂ̂ / ܂Ŕj󂵂Ȃ

	cmp	ecx,0f0000000h		;`FbNl
	ja	.alloc_all		;S󂫃蓖
	mov	eax,ecx			;蓖ėv
	add	eax,edx			;eax = KvAhX
	add	eax,3ffh		;[؎̂
	shr	eax,10			;eax = y[We[upɕKvȃ
	add	eax,ecx			;vʂ̃쐬ɕKvȃ
	cmp	eax,ebp ;=free_pages	;󂫃Ɣr
	jbe	.do_alloc		;΃蓖Ăjmp

.alloc_all:	;S󂫃蓖
	mov	ecx,ebp ;=free_pages	;󂫃[h
	movzx	eax,b [POOL_mem_pages]	;v[
	sub	ecx,eax			;\񃁃y[W
	ja	.mem_pool		;0 ȏȂ jmp
	add	ecx,eax			;lɖ߂(v[Ȃ)
.mem_pool:
	mov	eax,ecx			;S󂫃y[W
	add	eax,edx			;AhXꕪ̃AhX
	add	eax,3ffh		;[؏グ
	shr	eax,10			;eax = y[We[upɕKvȃ
	sub	ecx,eax			;󂫃y[W
	jb	.no_memory		;}CiXȂG[
.do_alloc:
	mov	ebp, [free_LINER_ADR]	;\tAhXۑ
	and	esi, 0xfffff000		;炵
	add	esi, ebp		;󂫃jAAhXɉZ
	mov	[free_LINER_ADR], esi	;炷

	push	ecx
	call	alloc_DOS_mem		;DOS擪Ɋ蓖
	pop	ecx
	jc	.no_memory		;G[jmp

	push	ecx
	sub	ecx, eax		;蓖čσy[W
	call	alloc_RAM		;蓖
	pop	ecx	; ecx͂܂g
	jc	.no_memory		;G[jmp

	;ZN^쐬
	call	search_free_LDTsel	;eax = 󂫃ZN^
	jc	.no_selector		;if G[ jmp
	mov	[Load_cs],eax		;ZN^lL^

	mov	edi,[work_adr]		;edi [NAhX
	add	ecx,edx			;ItZbĝZ
	dec	ecx			;page -1
	mov	[edi  ],ebp		;x[X
	mov	[edi+4],ecx		;limit
	mov	d [edi+8],0a00h		;R/X ^Cv / x=0

	inc	ecx			;ecx = TCY (page)
	shl	ecx,12			;ecx = TCY (byte)
	mov	[60h],ecx		;PSP ̈ɋL^
	call	make_mems_4k		;ZN^쐬 edi=\ eax=sel

	;ds 쐬
	call	search_free_LDTsel	;eax = 󂫃ZN^
	jc	.no_selector		;if G[ jmp
	mov	[Load_ds],eax		;ZN^lL^

	mov	ebx,[Load_cs]		;Rs[
	mov	ecx,eax			;Rs[
	mov	 ax,0200h		;R/W ^Cv / x=0
	call	make_alias		;GCAX쐬

	clc				;I
.exit:
	pop	ebp
	pop	esi
	pop	edx
	pop	ecx
	pop	eax
	ret

.no_memory:
.no_selector:
	stc
	jmp	.exit


;=============================================================================
;[hvOsTu[`
;=============================================================================
;	IN	fs	[hvO cs
;		gs	[hvO ds
;		edx	[hvO EIP
;		ebp	[hvO ESP
	align	4
run_exp:
	mov	eax,gs			;DS
	mov	 ss,eax			;
	mov	esp,ebp			;X^bN؂ւ

	push	fs			;cs
	push	edx			;EIP

	mov	ds,eax			;
	mov	es,eax			;ZN^ݒ
	mov	fs,eax			;
	;mov	gs,eax	; ݒ

	;
	;SĂ̔ėpWX^NAiN̏lj
	;
	xor	eax,eax
	xor	ebx,ebx
	xor	ecx,ecx
	xor	edx,edx
	xor	edi,edi
	xor	esi,esi
	xor	ebp,ebp

	;
	;ړIvO̎s
	;
	retf		;far return

;******************************************************************************
;f[^
;******************************************************************************
segment	data align=16 class=CODE use16
group	comgroup text data

;------------------------------------------------------------------------------
;EWX^_v\
;------------------------------------------------------------------------------
; db "Expection Interrupted : INT 00h -                                 ",13,10
; db "ErrorCode = ####_####  CS:EIP = ####:####_####  EFLAGS = ####_####",13,10
; db "DS = ####  ES = ####  SS = ####  FS = ####  GS = ####             ",13,10
; db "CR0 = ####_####  CR1 = ****_****  CR2 = ####_####  CR3 = ####_####",13,10
; db "EAX = ####_####  EBX = ####_####  ECX = ####_####  EDX = ####_####",13,10
; db "ESI = ####_####  EDI = ####_####  EBP = ####_####  ESP = ####_####",13,10
; db "$"

blue_screen:	;;	db 01Bh,"[46m"
		db "----------------------------------------"
		db "--------------------------",13,10
		db "Expection Interrupted : INT "
blue_intno	db "##h -                                 ",13,10,
regdump_msg	db "Err = " ;blue_err_strŏ̂ŕύX͒
blue_errorcode	db "####_####  "
blue_cseip	db "CS:EIP = "
blue_cs		db "####:"
blue_eip	db "####_####   SS:ESP = "
blue_ss		db "####:"
blue_esp	db "####_####",13,10,
regdump_ds	db " DS = "
blue_ds		db "####        ES = "
blue_es		db "####        FS = "
blue_fs		db "####        GS = "
blue_gs		db "####",13,10,"EAX = "
blue_eax	db "####_####  EBX = "
blue_ebx	db "####_####  ECX = "
blue_ecx	db "####_####  EDX = "
blue_edx	db "####_####",13,10,"ESI = "
blue_esi	db "####_####  EDI = "
blue_edi	db "####_####  EBP = "
blue_ebp	db "####_####  FLG = "
blue_eflags	db "####_####",13,10,"CR0 = "
blue_cr0	db "####_####  CR2 = "
;blue_cr1 / CPU ɑ݂Ȃ
blue_cr2	db "####_####  CR3 = "
blue_cr3	db "####_####  "
blue_flags	db "O  D  S  Z  C  ",13,10
		db "----------------------------------------"
		db "--------------------------",13,10
;;		db 0x1b,"[40;0m"
		db "$"
string_return	db '*Ret:*'
string_crlf	db 13,10,'$'

hexstr		db	"0123456789ABCDEF"

err_size	db	34
err_max		db	12h
			;1234567890123456789012345678901234
err_00		db	'00h - Zero Divide Error           '
err_01		db	'01h - Debug Exceptions            '
err_02		db	'02h - NMI                         '
err_03		db	'03h - Breakpoint                  '
err_04		db	'04h - INTO Overflow Fault         '
err_05		db	'05h - Bounds Check Fault          '
err_06		db	'06h - Invalid Opcode Fault        '
err_07		db	'07h - Coprocessor Not Available   '
err_08		db	'08h - Double Fault                '
err_09		db	'09h - Coprocessor Segment Overrun '
err_0a		db	'0Ah - Invalid TSS                 '
err_0b		db	'0Bh - Segment Not Present Fault   '
err_0c		db	'0Ch - Stack Exception Fault       '
err_0d		db	'0Dh - General Protection Exception'
err_0e		db	'0Eh - Page Fault                  '
err_0f		db	'0Fh - (CPU RESERVED)              '
err_10		db	'10h - Coprocessor Error           '
err_11		db	'11h - Alignment Fault             '
err_dmy		db	'1xh - Unknown (Stack broken?)     '

	align	4
dump_err_code	dd	-1
dump_orig_esp	dd	-1
dump_orig_ss	dd	-1
blue_err_str	db	"Err "
blue_int_str	db	"Int "

;------------------------------------------------------------------------------
;Et@CpX
;------------------------------------------------------------------------------
	align	4
nowenv		dd	0
nowpath_len	dd	0
;nowpath_pos	dd	0

nowpath		db	"1234567890123456789012345678901234567890"
		db	"1234567890123456789012345678901234567890","1234"
		db	0
		db	'$',0,0,0

;------------------------------------------------------------------------------
;Eexp t@C̃[h (routin made by nabe@abk)
;------------------------------------------------------------------------------
	align	4
data0		dd	0		;f[^ꎞޔp
data1		dd	0		;
data2		dd	0		;
data3		dd	0		;
data4		dd	0		;

file_handle	dd	0		;t@Cnh
Load_cs		dd	0		;[hZN^
Load_ds		dd	0		;



;##############################################################################
;##############################################################################
